# Documentation at the __END__
package Data::Properties::PropertiesReader;
#!/usr/bin/perl -w

# use strict;
use warnings;
use Properties;
use Data::Dumper;
use Tools::DependanciesViewer;
use Log::Message::Simple;
use version; our $VERSION = qv('0.2.1');
use feature qw(say);

# Only logs to console, not into HTML :)
# use CGI::Carp;

my @OL_list_ids = ();
my $properties_files_path = "../properties/";

# Dynamically open ou file and return contained data
sub get_properties_file{

	my ( $self, $file ) = @_;
	my $file_path = $properties_files_path . $file . ".properties";
	# Debug
	# carp( $file_path . "\n");

	if ( -e $file_path or warn "--- Properties file path is bad\n") {
	    # Loads the properties file for the Open Library Lists
	    my $library_lists_ids = Properties->new( $file_path );
	    if ( $microlibrary::log_mode ){
	        print "-- Properties $file.properties loaded\n";
	    }

	    if($library_lists_ids->error()){   # Check if something goes wrong...
	      if ( $microlibrary::log_mode ){
	        print("--- Error code: " . $library_lists_ids->get_errorCode() ."\n");
	        print("--- Error description: " . $library_lists_ids->get_errorDescription() ."\n");
	      }
	      $library_lists_ids->printStacktrace();
	    }

	    else{   # if everything's ok we load the properties file
	        my $properties_hash_ref = $library_lists_ids->getCompleteConfig();
	        my @keys = keys( %{ $properties_hash_ref } ); 
	        my $key;

	        if ($file eq "env"){
	        	$key = $keys[0];
	        } elsif ($file eq "open_library_lists" or $file eq "maps"){
                $key = join(", ", @keys)
	        } elsif ($file eq "modes" or $file eq "libraries_infos"){
	        	#my @keys = keys( %{ $properties_hash_ref })
	        	# Means that the log is not implemented
	        	$key = "Log not implemented yet for these properties keys\n",
	        } else{
	        	print "Properties Reader loader not implemented yet";
	        }

	        if ( $microlibrary::log_mode ){
    	        print ("--- $key found into $file.properties\n");
	        }

	        # DEBUG
	        # print Dumper $properties_hash_ref;
	        # print '$properties_hash_ref = ' . "\n";
	        #print Dumper $$properties_hash_ref{sandoth};
	       return $properties_hash_ref;
	    }
    }
}

# To debug, has not have been test extensively 
# Grosse merde buggée ?
sub get_list_ids {
	if ( $microlibrary::log_mode ){ 
		print "into get_list_id() !!!!!\n";
	}
	my ( $self, $props_hash_ref, $nick )= @_;
	my $OL_user_lists;
	if ( $microlibrary::log_mode ){
		print Dumper $props_hash_ref;
		# print "nick = $nick \n";

	}

	# @OL_list_ids = &get_lists_values( $$properties_hash_ref{sandoth} );
	@OL_list_ids = &get_lists_values( $props_hash_ref );

	if ( $microlibrary::log_mode ){ 
    	print "into get_list_id() again !!!!!\n";
	   print Dumper @OL_list_ids;
	}

#	if( $microlibrary::context{'home_page_flag'} eq "home" ){
#		if ( $microlibrary::log_mode ){
#			print "YOU'VE ASKED FOR HOME PAGE !!!";
#		}
#		$OL_user_lists = "home";
#	}

    #elsif( $home_flag eq "lib" ){
       if ( exists($props_hash_ref->{$nick}) ){
		   # Get keys of our hash
		   # See page 98-99Adam McDaniel book for this syntax
		   # my @OL_user_nick = keys %{ $props_hash_nick };
		   $OL_user_lists = $props_hash_ref->{$nick};

		   # Delete all spaces
		   $OL_user_lists =~ s/\s+//g;

		   if ( $microlibrary::log_mode ){ 
	    	   print "lists for $nick = $OL_user_lists\n";
		       print $OL_user_lists;
		   }
       }

       elsif( $nick eq "home" ) {
       	    my @fuckin_flag = ( 'home', 'sweet', 'home');
       	    return @fuckin_flag;
       }

       elsif( $nick eq "lib" ) {
       	my @fuckin_flag = ( 'lib' );
       	return @fuckin_flag;
       }

       else {
  	       if ( $microlibrary::log_mode ){
                # die "Got no nick !!!!!!!!!!!!!!!!!!!!!!!"
  	       }
            $OL_user_lists = "lib,lib";
       }

#        else {
#          die "Err 500 : The user $nick don't exists. Come back yesterday.";
#       }
	#}

	if ( $microlibrary::log_mode ){ 
		print "Separated\n";
	}
	my @separated_lists = split(',',$OL_user_lists );
	if ( $microlibrary::log_mode ){ 
		print Dumper @separated_lists;
	}

	# Retrieve number of element inside the hash
	# my $lists_quantity = keys %properties_hash;
	# DEBUG
	#print "List quantity = " . $lists_quantity . "\n";
	#for (my $counter = 1 ; $counter <= $lists_quantity; ) {
	 #   my $stag_list_selector = "staglist$counter";
	    # DEBUG
		#print $stag_list_selector . " id : " ;
		#print $$properties_hash_ref{$stag_list_selector} . "\n";
		#push ( @OL_list_ids, $$properties_hash_ref{$stag_list_selector} ); # We set the array with ids find
		# into the properties file
		#if ( $microlibrary::log_mode ){
		 # print "--- $stag_list_selector with id n°$$properties_hash_ref{$stag_list_selector}  loaded\n";
		#}
	   #$counter++;
	#}

	#my $key_name = "key";
	#print $key_name . "\n";
	#my @values = ( 'stag', 'foutaiz', 'sandoth', );
	#print $values[0] . "\n";
    #print $values[1] . "\n";
    #print $values[2] . "\n";
    #my @set = ( $key_name, @values );
    #print Dumper(@set);
	#die;

	#print Dumper( @OL_list_ids );
    return @separated_lists;
}


#sub get_OL_users{
#	 my @nicks = &get_nicks_keys($properties_hash_ref);
#    print "AFTER !!!!!!!!!!!!!!!!!!!!!!!!!!!\n";
#    print Dumper @nicks;
#}

sub get_nicks_keys{
	my ( $self, $props_hash_nick,  ) = @_;
	if ( $microlibrary::log_mode ){ 
		print 'Into get_nick_key(), %props_hash = ' . "\n";
        print Dumper $props_hash_nick;
	}

        my @OL_keys_list = keys %{ $props_hash_nick };
        if ( $microlibrary::log_mode ){
    	   print Dumper @OL_keys_list;
        }

#    if( $microlibrary::context{ 'home_page_flag' } eq "home"){
#        unshift( @OL_keys_list, $home_flag );
#        if ( $microlibrary::log_mode ){ 
#        	print Dumper @OL_keys_list;
#        }
#    }

    return @OL_keys_list;
}



sub get_lists_values{
	my  $props_hash_lists = shift;
	if ( $microlibrary::log_mode ){ 
		print 'Into get_lists_values(), %props_hash = ' . "\n";
    	print Dumper $props_hash_lists;
	}

	if( $props_hash_lists ){
	    # Get values of our hash
	    # See page 98-99Adam McDaniel book for this syntax
        my @raw_OL_list_ids = values %{ $props_hash_lists };
        if ( $microlibrary::log_mode ){
        	print '@values = ';
            print Dumper @raw_OL_list_ids;
        }
        # Avant il n'y avait pas de point virgule à la fin de cette ligne...
        return @raw_OL_list_ids;
	}
	else {
		die "No values into your properties file !!!";
	}
}

sub join{
	my @array;
    if ( $microlibrary::log_mode ){ 
    	print "joined \n";
    }
    # Makes an only string from an array
    my $joined_list = join('', @array );
    if ( $microlibrary::log_mode ){ 
    	print "JOINED !!!!! $joined_list\n";
    }
    return $joined_list;
}


sub new {
    my $class = shift;
    my $self = {};
    bless ($self, $class);
    if ( $microlibrary::log_mode ){
    	say "- New PropertiesReader";
    }
    return $self;
}

if ( $microlibrary::sad_deps_mode ){
    my $env_viewer = Tools::DependanciesViewer->new();
    $env_viewer->print_used_modules($0, %INC);
}



# DEBUG
# &dump_properties_hash_ref();
# sub dump_properties_hash_ref{
	# print Dumper( $properties_hash_ref );
	# print $$properties_hash_ref{stag}{list}{1} . " = identifiant1 de la liste du Stag\n";
	# print $$properties_hash_ref{stag}{list}{2} . " = identifiant2 de la liste du Stag\n";
	# print $$properties_hash_ref{stag}{list}{3} . " = identifiant2 de la liste du Stag\n";
	# print $$properties_hash_ref{stag}{list}{4} . " = identifiant2 de la liste du Stag\n";
#}

1;
__END__

=pod

=head1 NAME

Data::Properties::PropertiesReader - Read key-values peers into a file

=head1 DESCRIPTION

Let's go searching values (lists ids) into a properties file and return it to the
Data::CURL::CurlRequester.

=head1 VERSION

This is version 0.2.1, better known as a Chines Loony And A Rope
(the third Dime And A Shoestring)

=head1 CONFIGURATION AND ENVIRONMENT

We've got hard-coded name of our first library ('stag') in the code.
Feel free to change if needed.
See https://bugs.launchpad.net/bibliothek-project/+bug/856571

=head1 DEPENDENCIES

=over 4

=item B<< Properties >>

=back


=head1 SUBROUTINES / METHODS

=over 4

=item B<< get_list_ids() >>

Reads values (list ids) from a properties file. Store this values into an array
and returns it.

=back

=head1 BUGS AND LIMITATIONS

Hard coded values, see CONFIGURATION AND ENVIRONMENT section
https://bugs.launchpad.net/bibliothek-project/+bug/856571

=head1 AUTHOR

Self Shelf Swap - Simon Foutaiz - 2011-05-24

=head1 CURRENT MAINTAINER

    my ( $nickname = "smonff", $provider = "lavabit.com");
    print $nickname . "@" . $provider;

=head1 COPYRIGHT AND LICENSE

Copyright 2012 Self Shelf Swap.

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl himself.

=cut