# Documentation at the __END__
package Tools::DependanciesViewer;

#!/usr/bin/perl -w                                                                                                                                                                  
# © Simon Foutaiz
# 26 sept. 2011                                                                                                                          
# GNU GPL License
# description
use strict;
use warnings;
use File::Basename;

sub new {
    my $class = shift;
    my $self = {};
    bless ($self, $class);
    return $self;
}

sub print_used_modules{
   my ( 
        $self, 
        $script_name, # Name of the script where module has been called  
        %I_N_C, # %INC of the script where module has been called
    ) = @_;
	
	# print "Script name = $script_name \n";
	
	$script_name = basename($script_name); 
    print "Dependancies for $script_name : "; 
    print %I_N_C;
    print "\n";
	
}

1;
__END__

=pod

=head1 NAME                                                                                                                                                                                 

Tools::DependanciesViewer - A simple way to dump your %INC var

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR                                                                                                                                                                                                                                                                                          

Self Shelf Swap - Simon Foutaiz - 2011-05-19

=head1 VERSION

This is version 0.02.1, better known as a Chines Loony And A Rope
(the third Dime And A Shoestring)

=head1 CURRENT MAINTAINER

    my ( $nickname = "smonff", $provider = "lavabit.com");
    print $nickname . "@" . $provider;

=head1 COPYRIGHT AND LICENSE

Copyright 2012 Self Shelf Swap.

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl himself.

=cut

