#!/usr/bin/perl -w                                                                                                                                                                  
# © Self Shelf SwapSimon Foutaiz
# 27 oct. 2011                                                                                                                          
# GNU GPL License
# Tests for Data::RDF::RDFTool

# Une bonne pratique consiste à d'abord ajouter des tests dans le but de 
# reproduire une erreur constatée pour ensuite modifier le code fautif afin qu'il 
# passe les tests. L'intérêt de cette pratique, écrire les tests d'abord, 
# ne se limite pas à la reproduction des bugs.
# http://articles.mongueurs.net/magazines/linuxmag88.html

use strict;
use warnings;
use Test::More;
use Data::RDF::RDFTool;
use IO::File;
use Perl6::Slurp;
use XML::Simple;
use Data::Dumper;

plan tests => 16;
# plan 'no_plan'; # if test nbr not known

# Please change to test on another environment
$ENV{HOME} = "/home/foutaiz/Documents/open-art-mafia/perl/selfshelfswap_workspace/trunk/dime_and_a_shoestring/lib";
$microlibrary::log_mode = 0;
$microlibrary::html_mode = 0;


require_ok( 'IO::File' );
require_ok( 'Data::Dumper' );
require_ok( 'XML::Simple' );
require_ok( 'File::Basename' );
require_ok( 'Encode::Encoder' );
use_ok( 'IO::File' );
use_ok( 'Data::Dumper' );
use_ok( 'XML::Simple' );
use_ok( 'File::Basename' );
use_ok( 'Encode::Encoder' );


my $rdf_tool = Data::RDF::RDFTool->new;

my $range = 10_000;
my $random_number = int(rand($range));

my $flux_ref = IO::File->new;
my $flux_id = "test$random_number";

chdir "../database/list/";

# Should test with different files choose into the database
if( $flux_ref->open("< OL10727L.rdf") or print "No file" ){
    
    my $flux =  slurp $flux_ref;
    
    chdir "../../lib/";
    $rdf_tool->store_rdf_flux( $flux, $flux_id, "list" );
    $flux_ref->close; 
}


my $file_name = "test" . $random_number . ".rdf";
chdir "../database/list/";
my $file = new IO::File "< $file_name" or print "No file";

my $xml_flux = XML::Simple->new();
my $xml_flux_ref = $xml_flux->XMLin( "$file_name" );
#print Dumper $xml_flux_ref;


chdir "../../lib/";

my $parser = $rdf_tool->parse_RDF_file("test$random_number");



ok( defined $rdf_tool, 'New returned something' );
isa_ok( $rdf_tool, 'Data::RDF::RDFTool', '$rdf_tool');
can_ok( $rdf_tool, 
        qw( 
            get_book_element 
            get_book_id 
            get_book_request_url
            get_books_number_inside_list
            get_list_element
            parse_RDF_file
            store_rdf_flux
        )
);

chdir "../database/list/";

# Should test if minimal RDF data exists
my $key = $xml_flux_ref->{ "ol:key" };

ok( defined $file && defined $key, "Store RDF flux into $file_name" );
ok( defined $parser, "RDF file $file_name parsed");
ok( $key ne "", "$file_name seems to contain RDF flux");
