#!/usr/bin/perl -w                                                                                                                                                                  
# © Self Shelf SwapSimon Foutaiz
# 27 oct. 2011                                                                                                                          
# GNU GPL License
# Tests for View::WebDisplayer

# Une bonne pratique consiste à d'abord ajouter des tests dans le but de 
# reproduire une erreur constatée pour ensuite modifier le code fautif afin qu'il 
# passe les tests. L'intérêt de cette pratique, écrire les tests d'abord, 
# ne se limite pas à la reproduction des bugs.
# http://articles.mongueurs.net/magazines/linuxmag88.html

# A little bit shitty... But how can we do better??
package microlibrary;

use strict;
use warnings;
use Test::More;
use View::WebDisplayer;
use Data::Dumper;
use Text::Buffer;
use FileHandle;
use Perl6::Slurp;

plan tests => 5;
# plan 'no_plan'; # if test nbr not known

# Please change to test on another environment
$ENV{HOME} = "/home/foutaiz/Documents/open-art-mafia/perl/selfshelfswap_workspace/trunk/dime_and_a_shoestring/lib";
my $log_mode = '1';

#require_ok( '' );
#use_ok( '' );

my $view = View::WebDisplayer->new;
our $html_buffer = new Text::Buffer();

ok( defined $view, 'New view: this returned something' );
isa_ok( $view, 'View::WebDisplayer', '$$view');
can_ok( $view, 
        qw( 
            close_footer
            close_tag
            get_microlibrary_name
            header
            header_menu
            indent
            just_fucking_print
            logo
            make_sidebar_menu
            newline
            open_tag
            print_into_tags
            sidebar_menu
            unindent
            insert_JS
        )
);

# First test of the print_into_tag() with no attribute...
my $tag = "p";
my $content = "This is the content of the tag";
$view->print_into_tags("$content","$tag");

if ( $html_buffer->save("../html_buffer_test.txt")){
    if ( $microlibrary::log_mode ){
        print "Cache file has been updated !!!";
    }
}

my $supposed_content = "<"."$tag".">"."$content"."</"."$tag".">";

my $html_file_handler = FileHandle->new;
if ($html_file_handler->open("< ../html_buffer_test.txt")) {
    
    my $slurped_file = slurp($html_file_handler);
    
    # Delete any carriage return into our slurped file
    $slurped_file =~ s/\n//g;
    
    ok( $slurped_file eq $supposed_content, "Tag has been generated with it's content inside" );
    
    $html_file_handler->close;

} else {
    die("Oups, the file containing cached html don't exists...");
}

# ... second test of the print_into_tag() with one attribute...
$tag ="div";
my $attribute ="alt";
my $attr_value = "This is the value of our attribute";

my $view2 = View::WebDisplayer->new;
$view2->print_into_tags("$content", "$tag", "$attribute", "$attr_value");

if ( $html_buffer->save("../html_buffer_test2.txt")){
    if ( $microlibrary::log_mode ){
        print "Cache file has been updated !!!";
    }
}

$supposed_content = "<"."$tag"." "."$attribute=\"$attr_value\">"."$content"."</"."$tag".">";

if ($html_file_handler->open("< ../html_buffer_test2.txt")){

    $microlibrary::slurped_file = slurp($html_file_handler);
    
    # Vire les retours charriot
    $microlibrary::slurped_file =~ s/\n//g;
    
    print $microlibrary::slurped_file;
    print " - - - - \n";
    print $supposed_content;
    
    ok( $microlibrary::slurped_file eq $supposed_content, "Tag has been generated with it's content inside and it's attribute and it's value" );
    
    $html_file_handler->close;
    undef $html_buffer;
    
} else {
    die("Oups, the file containing cached html don't exists...");
}
    